<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
include("resize-class.php");
class Archivos extends CI_Controller
{
	
	function __construct()
	{
		parent::__construct();
		$this->load->model('admarchivos');	
		$this->load->helper('url');
		$this->load->helper('form');		
	}	
	
	function index($newidioma=null){
		$this->setupIdioma($newidioma);		 
           
		//Si no recibimos ningún valor proveniente del formulario, significa que el usuario recién ingresa:
        if(!isset($_POST['user_name'])){
			//Por lo tanto le presentamos la pantalla del formulario de ingreso: 
			$this->load->view('login');      
        }
        else{//Si el usuario ya pasó por la pantalla inicial y presionó el botón para poder entrar		
			
        }/*if*/
	}/*index*/
			
	
	//Para eliminar archivos
	public function eliminar(){
		$this->setupIdioma($newidioma);	
		
		$archivo=$this->input->post('arch');
		$cmateria=$this->input->post('mat');
		$tipo_arch=$this->input->post('tip');
		
		$targetPath = $_SERVER['DOCUMENT_ROOT']."/uploads/repmateria".$cmateria."/";
		
		if($tipo_arch=="v"){
			$targetPath.="videos/";
			$archivo.=".flv";
		}
		else if($tipo_arch=="i"){
			$targetPath.="img/";
			$archivo.=".jpg";
		}
		
		
		chmod($targetPath, 0777);	
		unlink($targetPath.$archivo); //por si acaso elimino una preexistente
		chmod($targetPath, 0755);
		//$res=$this->admarchivos->eliminar_recurso($cmateria,$archivo,$tipo_arch);
		
		return $res;
			
	}/*eliminar*/
	
	
	//Inicializa idioma	
	function setupIdioma($newidioma=null){
		if (!(is_null($newidioma))){//si el usuario no ha seleccionado cambiar de idioma
			$_SESSION["idioma"]=$newidioma;		   
		}
		if (!isset($_SESSION["idioma"])){
			$this->config->set_item('language', 'spanish');//idioma por defecto
			$this->lang->load('spanish','spanish');
			$_SESSION["idioma"]="es";
		}else{
			if($_SESSION["idioma"]=="en"){//cargar inglés
				$this->config->set_item('language', 'english');
				$this->lang->load('english','english');
			}
			elseif ($_SESSION["idioma"]=="es"){//cargar español
				$this->config->set_item('language', 'spanish');
				$this->lang->load('spanish','spanish');        
			} /*if*/
		} /*if*/
	} /*setupIdioma*/
	
	
	//obtiene el total de archivos
	private function total_archivos($ruta){
		$ds  = opendir($ruta);
		while (false !== ($nombre_archivo = readdir($ds))) {
			$archivos[] = $nombre_archivo;
		}/*while*/
		return count($archivos)-2;
	} /*totat_archivos*/
	
	
	/*
	 * Subir imágenes a la materia respectiva
	 * */
	public function uploadimg()
	{
		$carpeta=$_REQUEST['folder'].$_REQUEST['materia'];
		$dir=explode('/',$carpeta);
		chmod($_SERVER['DOCUMENT_ROOT']."/uploads/".$dir[3]."/", 0777);				
		//crear la ruta absoluta
        $targetPath = $_SERVER['DOCUMENT_ROOT']."/uploads/".$dir[3]."/img/";
        if (!empty($_FILES)) {
            $nombreArchivo = $_FILES['Filedata']['name'];
			$tempFile = $_FILES['Filedata']['tmp_name'];
			$targetFile =  $targetPath.$nombreArchivo;
		
			if(move_uploaded_file($tempFile,$targetFile))
			{				
				// *** 1) Initialise / load image
				$resizeObj = new resize($targetFile);

				// *** 2) Resize image (options: exact, portrait, landscape, auto, crop)
				$resizeObj -> resizeImage(400, 400, 'crop');

				// *** 3) Save image
				$n_archivo='imagen'.$this->total_archivos($targetPath).'.jpg';
				$ruta_archivo=$targetPath.$n_archivo;	
				unlink($ruta_archivo); //por si acaso elimino una preexistente
				$resizeObj -> saveImage($ruta_archivo, 100);
				
				//Registrar en recurso en la base de datos				
				$res=$this->admarchivos->addrecurso($_REQUEST['usuario'],$_REQUEST['materia'],$ruta_archivo,$n_archivo,'i');
				
				unlink($targetFile); //elimino la imagen original				
			}/*if*/
		}/*if*/
		//chmod($_SERVER['DOCUMENT_ROOT']."/uploads/".$dir[3]."/", 0755);
		echo 1;
	}/*uploadimg*/
	
	
	public function uploadvideo()
	{				
		$carpeta=$_REQUEST['folder'].$_REQUEST['materia'];		
		$dir=explode('/',$carpeta);
		
		chmod($_SERVER['DOCUMENT_ROOT']."/uploads/".$dir[3]."/", 0777);				
		//crear la ruta absoluta
        $targetPath = $_SERVER['DOCUMENT_ROOT']."/uploads/".$dir[3]."/videos/";
        if (!empty($_FILES)) {
            $nombreArchivo = $_FILES['Filedata']['name'];
			$tempFile = $_FILES['Filedata']['tmp_name'];
			$targetFile =  $targetPath.$nombreArchivo;
			if(move_uploaded_file($tempFile,$targetFile))
			{			
				
				$n_archivo="video".$this->total_archivos($targetPath).".flv";	
				$targetPath=$targetPath.$n_archivo;
				$imagenes=(exec("ffmpeg -y -i '".$targetFile."' -threads 2 -s 320x240 -r 30.00 -threads 1 -pix_fmt yuv420p -g 300 -qmin 3 -b 512k -async 50 -ar 11025 -ac 1 -ab 16k '".$targetPath."' 2>&1",$output));
				unlink($targetFile);
				//Registrar en recurso en la base de datos				
				$res=$this->admarchivos->addrecurso($_REQUEST['usuario'],$_REQUEST['materia'],$targetPath,$n_archivo,'v');
				
				
			}
		}
		//chmod($_SERVER['DOCUMENT_ROOT']."/uploads/".$dir[3]."/", 0755);
		echo 1;
	}/*uploadvideo*/
	
	
	//Ver imagen
	public function ver_img($archivo,$cmateria,$newidioma=null){
		$this->setupIdioma($newidioma);	
				
		$datos['arch']=$archivo;
		$datos['im']=$cmateria;
		
		$datos['publicador']=$this->admarchivos->obtener_publicador($cmateria,$archivo,"i");
		
		$datos['c_usuario']=$this->admarchivos->obtener_codUsuario($cmateria,$archivo,"i");
		
		$datos['fecha_pub']=$this->admarchivos->obtener_fecha_pub($cmateria,$archivo,"i");
		
		$datos['ruta_arch']=$this->admarchivos->obtener_ruta($cmateria,$archivo,"i");
				
		$this->load->view('desplegar_img',$datos);
	} /*ver_img*/
	
	
	//Ver video
	public function ver_video($archivo,$cmateria,$newidioma=null){
		$this->setupIdioma($newidioma);	
		
		$datos['arch']=$archivo;
		$datos['im']=$cmateria;
		
		$datos['publicador']=$this->admarchivos->obtener_publicador($cmateria,$archivo,"v");
		
		$datos['c_usuario']=$this->admarchivos->obtener_codUsuario($cmateria,$archivo,"v");
		
		$datos['fecha_pub']=$this->admarchivos->obtener_fecha_pub($cmateria,$archivo,"v");
		
		$datos['ruta_arch']=$this->admarchivos->obtener_ruta($cmateria,$archivo,"v");
				
		$this->load->view('reproducir',$datos);
	} /*ver_video*/
}
