<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Cursos extends CI_Controller
{
	private $limit=3;
	function __construct()
	{
		parent::__construct();
		$this->load->model('consultas');
		$this->load->model('admcursos');
		$this->load->helper('url');
		$this->load->helper('form');		
	}	
	
	function index($newidioma=null){
		$this->setupIdioma($newidioma);		 
           
		//Si no recibimos ningún valor proveniente del formulario, significa que el usuario recién ingresa:
        if(!isset($_POST['user_name'])){
			//Por lo tanto le presentamos la pantalla del formulario de ingreso: 
			$this->load->view('login');      
        }
        else{//Si el usuario ya pasó por la pantalla inicial y presionó el botón para poder entrar		
			
        }/*if*/
	}/*index*/
	
	
	//Actualiza los datos del curso desde el controlador
	public function actcursos(){
		$idc=$this->input->post('idcurso');
		$tit=$this->input->post('titulo_c');
		$desc=$this->input->post('descrip_c');
		$estado=$this->input->post('estado');
		$idioma=$this->input->post('idioma');

		$tit=$this->security->xss_clean($tit);
		$desc=$this->security->xss_clean($desc);		
		
		$res=$this->admcursos->updtcurso($idc,$tit,$desc,$estado,$idioma);
		if($res) echo 1;	//Se actualizó correctamente										
		else echo 0;		//No se pudo actualizar
				
	} /*actcursos*/
	
	
	//Desliega formulario para agrecar curso
	public function addcursos($newidioma=null){
		$this->setupIdioma($newidioma);	
		
		$datos['idiomas'] =$this->consultas->getIdiomas();		
						
		$this->load->view('admcursos/agregar',$datos);
	} /*addcursos*/
	
	
	//Genera opciones para submenú	
	public function admincursos($newidioma=null){
		$this->setupIdioma($newidioma);
		
		$datos = array(
				      'submenu' =>array
							   ('<a href="cursos/addcursos">'.$this->lang->line('make').'</a>',
								'<a href="cursos/findcursos">'.$this->lang->line('find').'</a>',
							    '<a href="cursos/listcursos">'.$this->lang->line('list').'</a>'							    
							   )			      							   
				);						
		$this->load->view('admcursos/maincurso',$datos);
	} /*admincursos*/
	
	
	//Encontrar cursos
	public function enccursos($offset = 0,$newidioma=null){
		$this->setupIdioma($newidioma);	
	
		$parametro1=$this->input->post('parametro1');
		if ((isset($parametro1)) && ($parametro1 != "")) {
			unset($_SESSION['parametro1']);
			$_SESSION['parametro1']=$parametro1;
		}/*if*/
					
		$uri_segment=3;
		$offset=$this->uri->segment($uri_segment);
		
		$datos['indice']=$offset;
		
		if($offset==0)$datos['indice']=0;		
		$this->load->library('pagination');
		
		//Verificando que las sesión se encuentre definida

		if ((isset($_SESSION['parametro1'])) && ($_SESSION['parametro1']!="")) {
			$datos['cursos_r']=$this->admcursos->obtener_lista_paginada_filt($_SESSION['parametro1'],$this->limit,$offset);
			$config['total_rows']=$this->admcursos->contar_todos_filtro($_SESSION['parametro1']);	
		}/*if*/
		
		if($config['total_rows']==0){
			$this->load->view('noregistros');
		}else{
			$config['base_url']=site_url('cursos/enccursos/');
			$config['first_link'] = $this->lang->line('linkfirst');
			$config['last_link'] = $this->lang->line('linklast');
			$config['next_link'] = $this->lang->line('linknext');
			$config['per_page']=$this->limit;
			$config['prev_link'] = $this->lang->line('linkprev');
					
			$config['uri_segment']=$uri_segment;
			
			$this->pagination->initialize($config);
			$datos['paginacion']=$this->pagination->create_links();			
			$datos['filtro']=true;
			$datos['total_reg']=$config['total_rows'];
			$this->load->view('admcursos/listar',$datos);
		}/*if*/
    } /*enccursos*/
    
	
	//Desliega lista de administración de usuarios
	public function findcursos($newidioma=null){
		$this->setupIdioma($newidioma);	
		
		$datos['idiomas'] =$this->consultas->getIdiomas();	
		
		//Borrando variables de búsquedas anteriores
		unset($_SESSION['parametro1']);
		unset($_SESSION['parametro2']);	
						
		$this->load->view('admcursos/listarfiltro',$datos);
	} /*findcursos*/
	
	
	public function listcursos($offset = 0,$newidioma=null){
		$this->setupIdioma($newidioma);	
		$uri_segment=3;
		$offset=$this->uri->segment($uri_segment);
		
		$datos['cursos_r']=$this->admcursos->obtener_lista_paginada($this->limit,$offset);
		$datos['indice']=$offset;
		
		if($offset==0)$datos['indice']=0;
		$this->load->library('pagination');
		
		$config['total_rows']=$this->admcursos->contar_todos();	
		if($config['total_rows']==0){
			$this->load->view('noregistros');
		}else{			
			$config['base_url']=site_url('cursos/listcursos/');
			$config['first_link'] = $this->lang->line('linkfirst');
			$config['last_link'] = $this->lang->line('linklast');
			$config['next_link'] = $this->lang->line('linknext');
			$config['per_page']=$this->limit;
			$config['prev_link'] = $this->lang->line('linkprev');
			$config['uri_segment']=$uri_segment;
			
			$this->pagination->initialize($config);
			$datos['paginacion']=$this->pagination->create_links();			
			$datos['filtro']=false;
			
			$datos['total_reg']=$config['total_rows'];	
			$this->load->view('admcursos/listar',$datos);
		}/*if*/
    } /*listusuarios*/
	
	
	/*Devuelve las materias*/
	function materias_curso(){
		$idcurso=$this->input->post('parametro');
		
		$materias=$this->admcursos->obtener_materias($idcurso);
		
		$opciones="";
		foreach($materias as $dato=>$valor){
			$opciones.="<option value=\"".$valor[0]."\">".$valor[1]."</option>";	
		}
				
		$datos['listaopt']=$opciones;
		$this->load->view('opciones_select',$datos);		
		
	} /*materias_curso*/
	
	/*Realizar nueva búsqueda*/
	function nenccursos(){
		unset($_SESSION['parametro1']);
	} /*nenccursos*/
	
	
	//Registra los datos del usuario desde el controlador
	public function regcursos(){		
		$tit=$this->input->post('titulo_c');
		$desc=$this->input->post('descrip_c');
		$estado=$this->input->post('estado');
		$idioma=$this->input->post('idioma');
			
		$tit=$this->security->xss_clean($tit);
		$desc=$this->security->xss_clean($desc);
		
		$res=$this->admcursos->addcurso($tit,$desc,$estado,$idioma);
		if($res) echo 1;	//Se agregó correctamente										
		else echo 0;		//No se pudo agregar
				
	} /*regcursos*/	
	
	
	function setupIdioma($newidioma=null){
		if (!(is_null($newidioma))){//si el usuario no ha seleccionado cambiar de idioma
			$_SESSION["idioma"]=$newidioma;		   
		}
		if (!isset($_SESSION["idioma"])){
			$this->config->set_item('language', 'spanish');//idioma por defecto
			$this->lang->load('spanish','spanish');
			$_SESSION["idioma"]="es";
		}else{
			if($_SESSION["idioma"]=="en"){//cargar inglés
				$this->config->set_item('language', 'english');
				$this->lang->load('english','english');
			}
			elseif ($_SESSION["idioma"]=="es"){//cargar español
				$this->config->set_item('language', 'spanish');
				$this->lang->load('spanish','spanish');        
			} /*if*/
		} /*if*/
	} /*setupIdioma*/
	
	
	/*
	 * $filtro: Se ocupa para saber si tiene filtro y determinar cuál div se debe recargar
	 * $pag: Se ocupa en la acción de "Volver" para saber desde cuál página de la lista se hace la consulta
	 * $acc: Si va a modificar o editar
	 * $id:  Id del curso
	 * */
	public function vercurso($filtro,$pag=0,$acc,$id,$newidioma=null){
		$this->setupIdioma($newidioma);	
		
		$datos['curso']=$this->admcursos->obtener_curso($id);		
		$datos['idioma']=$this->consultas->obtener_idioma_instancia($datos['curso'][0]->lang);		
		$datos['p']=$pag;				//Desde qué página se realiza la consulta para saber a cuál página regresar 
		$datos['tienefiltro']=$filtro;	//Saber si se tratra de una página filtrada o no.
		
		if($acc=="v")$this->load->view('admcursos/ver',$datos);
		else if($acc=="e"){
			$datos['idiomas']=$this->consultas->getIdiomas();						//Para el caso que fuera actualización
			$this->load->view('admcursos/editar',$datos);
		}/*if*/
    } /*vercurso*/
}
