<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Examenes extends CI_Controller
{
	private $limit=3;
	function __construct()
	{
		parent::__construct();
		$this->load->model('consultas');
		$this->load->model('admexamenes');
		$this->load->helper('url');
		$this->load->helper('form');		
	}	
	
	function index($newidioma=null){
		$this->setupIdioma($newidioma);		 
           
		//Si no recibimos ningún valor proveniente del formulario, significa que el usuario recién ingresa:
        if(!isset($_POST['user_name'])){
			//Por lo tanto le presentamos la pantalla del formulario de ingreso: 
			$this->load->view('login');      
        }
        else{//Si el usuario ya pasó por la pantalla inicial y presionó el botón para poder entrar		
			
        }/*if*/
	}/*index*/
	
	
	//Desliega formulario para agregar titular examen
	public function addexamenes($newidioma=null){
		$this->setupIdioma($newidioma);		
			
		$datos['idiomas'] =$this->consultas->getIdiomas();		
						
		$this->load->view('admexamenes/agregar',$datos);
	} /*addexamenes*/
	
	
	/*
	 * Se utiliza para definir una publicación
	 * $pag: Se ocupa en la acción de "Volver" para saber desde cuál página de la lista se hace la consulta
	 * $id:  Id del examen
	 * $idpub: Código de publicación
	 * */
	public function definir($pag=0,$id,$idpub,$newidioma=null){
		$this->setupIdioma($newidioma);
		$datos['p']=$pag;				//Desde qué página se realiza la consulta para saber a cuál página regresar 
		//Cargar modelo	
		$this->load->model('admusuarios');
		
		//Se debe obtener el idioma
		$l=$this->admexamenes->obtener_idioma($id);
		
		$datos['info_ex']=$this->admexamenes->obtener_detalle_publicar($id,$l);
		$datos['info_ex'][3]=$this->admusuarios->obtener_nombre_completo($datos['info_ex'][3]);
		$datos['cpub']=$idpub;
		$this->load->view('admexamenes/definir_publicacion',$datos);
				
    } /*definir*/
    
    
    /*
	 * Se utiliza para definir una publicación
	 * $pag: Se ocupa en la acción de "Volver" para saber desde cuál página de la lista se hace la consulta
	 * $id:  Id del examen
	 * $idpub: Código de publicación
	 * */
	public function detallar_publicacion($pag=0,$id,$idpub,$newidioma=null){
		$this->setupIdioma($newidioma);
		$datos['p']=$pag;				//Desde qué página se realiza la consulta para saber a cuál página regresar 
		//Cargar modelo	
		$this->load->model('admusuarios');
		
		//Se debe obtener el idioma
		$l=$this->admexamenes->obtener_idioma($id);
		
		$datos['info_ex']=$this->admexamenes->obtener_detalle_publicacion($id,$l,$idpub);
		$datos['info_ex'][3]=$this->admusuarios->obtener_nombre_completo($datos['info_ex'][3]);
		$datos['cpub']=$idpub;
		$this->load->view('admexamenes/detallar_publicacion',$datos);
				
    } /*detallar_publicacion*/
    
    
	//Desliega formulario para agregar titular examen
	public function preguntas_publicar($ide,$idc,$totp,$totpr,$idm,$newidioma=null){
		$this->setupIdioma($newidioma);		
		$this->load->model('admmaterias');
		$datos['maxPregView'] = 5;
		$datos['totalPreg'] =$totp;
		$datos['totalPregReg'] =$totpr;
		$datos['codigoEx'] =$ide;
		$datos['codigoCat'] =$idc;		
		$datos['imagenes_repo']=$this->admmaterias->obtener_recurso($idm,'i');
		$datos['videos_repo']=$this->admmaterias->obtener_recurso($idm,'v');
		switch ($idc) {
			case 1:
				$this->load->view('admexamenes/reg_preguntas_fv',$datos);
				break;
			case 2:
				$this->load->view('admexamenes/reg_preguntas_sel',$datos);
				break;
			case 3:
				$this->load->view('admexamenes/reg_preguntas_comp',$datos);
				break;
		}
	} /*preguntas_publicar*/
	
	
	//Desliega formulario para agregar preguntas al examen en base a la categoría seleccionada
	public function addpreguntas($ide,$idc,$totp,$totpr,$idm,$newidioma=null){
		$this->setupIdioma($newidioma);		
		$this->load->model('admmaterias');
		$datos['maxPregView'] = 5;
		$datos['totalPreg'] =$totp;
		$datos['totalPregReg'] =$totpr;
		$datos['codigoEx'] =$ide;
		$datos['codigoCat'] =$idc;		
		$datos['imagenes_repo']=$this->admmaterias->obtener_recurso($idm,'i');
		$datos['videos_repo']=$this->admmaterias->obtener_recurso($idm,'v');
		switch ($idc) {
			case 1:
				$this->load->view('admexamenes/reg_preguntas_fv',$datos);
				break;
			case 2:
				$this->load->view('admexamenes/reg_preguntas_sel',$datos);
				break;
			case 3:
				$this->load->view('admexamenes/reg_preguntas_comp',$datos);
				break;
		}		
	} /*addpreguntas*/
	
	
	//Despliega las preguntas para que el usuario seleccione las que se van a publicar
	public function viewpreguntas_pub($ide,$idc,$idm,$iddetallepub,$newidioma=null){
		$this->setupIdioma($newidioma);		
		$this->load->model('admmaterias');
		//$datos['maxPregView'] = 5;
		//$datos['totalPreg'] =$totp;
		//$datos['totalPregReg'] =$totpr;
		$datos['codigoEx'] =$ide;
		$datos['codigoCat'] =$idc;
		$datos['codigoMat'] =$idm;
		$datos['codigoDetallePub']=$iddetallepub;
		$datos['imagenes_repo']=$this->admmaterias->obtener_recurso($idm,'i');
		$datos['videos_repo']=$this->admmaterias->obtener_recurso($idm,'v');
		$datos['preguntas']=$this->admexamenes->obtener_preguntas($ide,$idc);
		$datos['total_preguntas_detalle_pub']=$this->admexamenes->obtener_total_preguntas_detalle_publicacion($iddetallepub);
		switch ($idc) {
			case 1:				
				$this->load->view('admexamenes/ver_preguntas_fv_pub',$datos);
				break;
			case 2:
				$this->load->view('admexamenes/ver_preguntas_sel_pub',$datos);
				break;
			case 3:
				$this->load->view('admexamenes/ver_preguntas_comp_pub',$datos);
				break;
		}		
	} /*viewpreguntas_pub*/
	
	
	//Genera opciones para submenú	
	public function adminexamenes($newidioma=null){
		$this->setupIdioma($newidioma);
		
		$datos = array(
				      'submenu' =>array
							   ('<a href="examenes/addexamenes">'.$this->lang->line('make').'</a>',
								'<a href="examenes/completar">'.$this->lang->line('complete').'</a>',
							    '<a href="examenes/publicar">'.$this->lang->line('publish').'</a>',
							    '<a href="examenes/listpublicaciones/">'.$this->lang->line('my_publications').'</a>'							    
							   )			      							   
				);						
		$this->load->view('admexamenes/mainexamen',$datos);
	} /*admincursos*/
	
	
	/*Desplegar formulario para buscar el examen y completarlo*/
	function completar($newidioma=null){
		$this->setupIdioma($newidioma);
				
		$datos['idiomas'] =$this->consultas->getIdiomas();
		
		$this->load->view('admexamenes/completar_ex',$datos);
		
	} /*completar*/
	
	
	/*Devuelve las categorías disponibles para los examenes*/
	function categoria_disp(){
		$idcat=$this->input->post('parametro');
		
		$categorias=$this->admexamenes->obtener_categorias($idcat);
		
		$opciones="";
		foreach($categorias as $dato=>$valor){
			$opciones.="<option value=\"".$valor[0]."\">".$valor[1]."</option>";	
		}
				
		$datos['listaopt']=$opciones;
		$this->load->view('opciones_select',$datos);		
		
	} /*examenes_categoria*/
	
	
	/*Devuelve lo cursos disponibles*/
	function cursos_disp(){
		$ididioma=$this->input->post('parametro1');
		$idusuario=$this->input->post('parametro2');
		
		$cursosd=$this->admexamenes->obtener_cursos($ididioma,$idusuario);
		
		$opciones="";
		foreach($cursosd as $dato=>$valor){
			$opciones.="<option value=\"".$valor[0]."\">".$valor[1]."</option>";	
		}
				
		$datos['listaopt']=$opciones;
		$this->load->view('opciones_select',$datos);		
		
	} /*examenes_curso*/
	
	
	/*Devuelve los examenes creados por un profesor*/
	function examenes_pro(){
		$idm=$this->input->post('parametro1');
		$idp=$this->input->post('parametro2');
		
		$examenesd=$this->admexamenes->obtener_examenes_pro($idm,$idp);
		
		$opciones="";
		foreach($examenesd as $dato=>$valor){
			$opciones.="<option value=\"".$valor[0]."\">".$valor[1]."</option>";	
		}
				
		$datos['listaopt']=$opciones;
		$this->load->view('opciones_select',$datos);
		
	} /*examenes_pro*/
	
		
	public function listpublicaciones($offset = 0,$newidioma=null){
		$this->setupIdioma($newidioma);	
		$uri_segment=3;
		$offset=$this->uri->segment($uri_segment);
		
		$datos['publicaciones_prof']=$this->admexamenes->obtener_lista_publicaciones_paginada($_SESSION['usuario'],$this->limit,$offset);
		$datos['indice']=$offset;
		
		if($offset==0)$datos['indice']=0;
		$this->load->library('pagination');
		
		$config['total_rows']=$this->admexamenes->contar_todas_publicaciones_profesor($_SESSION['usuario']);	
		if($config['total_rows']==0){
			$this->load->view('noregistros');
		}else{			
			$config['base_url']=site_url('examenes/listpublicaciones/');
			$config['first_link'] = $this->lang->line('linkfirst');
			$config['last_link'] = $this->lang->line('linklast');
			$config['next_link'] = $this->lang->line('linknext');
			$config['per_page']=$this->limit;
			$config['prev_link'] = $this->lang->line('linkprev');
			$config['uri_segment']=$uri_segment;
			
			$this->pagination->initialize($config);
			$datos['paginacion']=$this->pagination->create_links();			
			$datos['filtro']=false;
			
			$datos['total_reg']=$config['total_rows'];	
			$this->load->view('admexamenes/listar_publicaciones_profesor',$datos);
		}/*if*/
    } /*listusuarios*/
    
    	
	/*Devuelve las materias*/
	function materias_curso(){
		$idcurso=$this->input->post('parametro1');
		$idusuario=$this->input->post('parametro2');
		
		$materias=$this->admexamenes->materias_profesor($idcurso,$idusuario);
		
		$opciones="";
		foreach($materias as $dato=>$valor){
			$opciones.="<option value=\"".$valor[0]."\">".$valor[1]."</option>";	
		}
				
		$datos['listaopt']=$opciones;
		$this->load->view('opciones_select',$datos);		
		
	} /*materias_curso*/
	
	
	/*Desplegar formulario para buscar el examen y completarlo*/
	function publicar($newidioma=null){
		$this->setupIdioma($newidioma);
				
		$datos['idiomas'] =$this->consultas->getIdiomas();
		
		$this->load->view('admexamenes/publicar_ex',$datos);
		
	} /*completar*/
	
	
	/*Devuelve las materias el tipo de la categoría seleccionada*/
	function obtener_tipo($newidioma=null){
		$this->setupIdioma($newidioma);	
		$cat=$this->input->post('parametro1');
		$idioma_sel=$this->input->post('parametro2');
		
		$categoria_selecionada=$this->admexamenes->obtener_tipo_cat($cat,$idioma_sel);
		
		$datos['cat_selec']=$categoria_selecionada;
		$this->load->view('admexamenes/agregar_tipo',$datos);		
		
	} /*obtener_tipo_cat*/
	
	
	//Registra la definición de una publiación
	public function regdefinir(){
		$cpub=$this->input->post('idpub');
				
		$res=$this->admexamenes->adddefinicion($cpub,$this->input->post());
		if($res) echo 1;	//Se agregó correctamente										
		else echo 0;		//No se pudo agregar
				
	} /*regdefinir*/
	
	
	//Registra los datos principales del examen
	public function regexamenes(){
		$tit_e=$this->input->post('titulo_e');
		$instructions_e=$this->input->post('indicaciones');
		$totpreg_e=$this->input->post('totp');
		$tiempo_e=$this->input->post('tiempoest');
		$idioma_e=$this->input->post('idioma');
		$categoria_e=$this->input->post('categoria_r');
		$curso_e=$this->input->post('curso_r');
		$materia_e=$this->input->post('materia_r');
		$creador_e=$this->input->post('usuario');
		
		if($this->input->post('fv')){
			$fv_e=$this->input->post('fv');			
			$fv_e=$this->security->xss_clean($fv_e);			
		}else{
			$fv_e=null;
		}/*if*/
		if($this->input->post('sel')){
			$sel_e=$this->input->post('sel');
			$sel_e=$this->security->xss_clean($sel_e);			
		}else{
			$sel_e=null;
		}/*if*/
		if($this->input->post('com')){
			$com_e=$this->input->post('com');
			$com_e=$this->security->xss_clean($com_e);
		}else{
			$com_e=null;
		}/*if*/
		
		$tit_e=$this->security->xss_clean($tit_e);
		$instructions_e=$this->security->xss_clean($instructions_e);
		$totpreg_e=$this->security->xss_clean($totpreg_e);
		$tiempo_e=$this->security->xss_clean($tiempo_e);		
				
		$res=$this->admexamenes->addexamen($tit_e,$instructions_e,$totpreg_e,$tiempo_e,$idioma_e,$categoria_e,$materia_e,$fv_e,$sel_e,$com_e,$creador_e);
		
		if($res) echo 1;	//Se agregó correctamente										
		else echo 0;		//No se pudo agregar
				
	} /*regexamenes*/
	
		
	//Registra las ponderaciones de las categorías que conforman una publicación
	public function regponderaciones_publicacion(){
		$res=$this->admexamenes->addponderaciones_publicacion($this->input->post());
		if($res) echo 1;	//Se agregó correctamente										
		else echo 0;		//No se pudo agregar
	} /*regponderaciones_publicacion*/
	
	
	//Registra preguntas del examen
	public function regpreguntas(){
		$cexa=$this->input->post('cex');
		$catp=$this->input->post('catpreg');
		
		$res=$this->admexamenes->addpreguntas($cexa,$catp,$this->input->post());
		if($res) echo 1;	//Se agregó correctamente										
		else echo 0;		//No se pudo agregar
				
	} /*regpreguntas*/
	
	
	//Registra preguntas para una categoría que conforma una publicación
	public function regpreguntas_publicacion(){
		$cod_detalle_pub=$this->input->post('dp');
		$res=$this->admexamenes->addpreguntas_publicacion($cod_detalle_pub,$this->input->post());
		if($res) echo 1;	//Se agregó correctamente										
		else echo 0;		//No se pudo agregar
	} /*regpreguntas_publicacion*/
	
	//Registra publicacion
	public function regpublicacion(){
		$cexa=$this->input->post('parametro1');
		$cprof=$this->input->post('parametro2');
		$cprof=$_SESSION['usuario'];
		$res=$this->admexamenes->addpublicacion($cexa,$cprof);
		if($res) echo 1;	//Se agregó correctamente										
		else echo 0;		//No se pudo agregar
				
	} /*regpublicacion*/
	
	
	//Deuelve el detalle del examen
	public function ver_detalle_examen($newidioma=null){
		$this->setupIdioma($newidioma);
		$ide=$this->input->post('parametro1');
		$idl=$this->input->post('parametro2');
		$datos['idmateria']=$this->input->post('parametro3');
		
		$datos['info_ex']=$this->admexamenes->obtener_detalle($ide,$idl);
		
		$this->load->view('admexamenes/detalle_ex',$datos);			
				
	} /*detalle_examen*/
	
	//Deuelve el detalle de informacion del examen para publicar
	public function ver_informacion_examen($newidioma=null){
		$this->setupIdioma($newidioma);
		$this->load->model('admusuarios');
		$ide=$this->input->post('parametro1');
		$idl=$this->input->post('parametro2');
		$datos['idmateria']=$this->input->post('parametro3');
		
		$datos['info_ex']=$this->admexamenes->obtener_detalle_publicar($ide,$idl);
		$datos['info_ex'][3]=$this->admusuarios->obtener_nombre_completo($datos['info_ex'][3]);
		$this->load->view('admexamenes/detalle_ex_publicar',$datos);			
				
	} /*ver_informacion_examen*/
	
	
	function setupIdioma($newidioma=null){
		if (!(is_null($newidioma))){//si el usuario no ha seleccionado cambiar de idioma
			$_SESSION["idioma"]=$newidioma;		   
		}
		if (!isset($_SESSION["idioma"])){
			$this->config->set_item('language', 'spanish');//idioma por defecto
			$this->lang->load('spanish','spanish');
			$_SESSION["idioma"]="es";
		}else{
			if($_SESSION["idioma"]=="en"){//cargar inglés
				$this->config->set_item('language', 'english');
				$this->lang->load('english','english');
			}
			elseif ($_SESSION["idioma"]=="es"){//cargar español
				$this->config->set_item('language', 'spanish');
				$this->lang->load('spanish','spanish');        
			} /*if*/
		} /*if*/
	} /*setupIdioma*/
}
