<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Materias extends CI_Controller
{
	private $limit=3;
	function __construct()
	{
		parent::__construct();
		$this->load->model('consultas');
		$this->load->model('admmaterias');
		$this->load->helper('url');
		$this->load->helper('form');		
	}	
	
	function index($newidioma=null){
		$this->setupIdioma($newidioma);		 
           
		//Si no recibimos ningún valor proveniente del formulario, significa que el usuario recién ingresa:
        if(!isset($_POST['user_name'])){
			//Por lo tanto le presentamos la pantalla del formulario de ingreso: 
			$this->load->view('login');      
        }
        else{//Si el usuario ya pasó por la pantalla inicial y presionó el botón para poder entrar		
			
        }/*if*/
	}/*index*/
	
	
	//Actualiza los datos del curso desde el controlador
	public function actmaterias(){
		$id=$this->input->post('idmateria');
		$curso=$this->input->post('curso_r');
		$tit=$this->input->post('materia_c');		
		$estado=$this->input->post('estado');
		$idioma=$this->input->post('idioma');
		$docentes=$this->input->post('profesores');
		$encargado=$this->input->post('titular');
			
		$tit=$this->security->xss_clean($tit);
	
		$res=$this->admmaterias->updtmateria($curso,$tit,$estado,$idioma,$encargado,$docentes,$id);
		if($res) echo 1;	//Se actualizó correctamente										
		else echo 0;		//No se pudo agregar
				
	} /*actcursos*/
	
	
	//Desliega formulario para agrecar direcotrios a repositorio de materias
	public function adddirectorios($newidioma=null){
		$this->setupIdioma($newidioma);
		
		$datos['cursosr'] =$this->admmaterias->obtener_cursos();			
						
		$res=$this->load->view('admmaterias/directorios',$datos);
		echo $res;
		
	} /*adddirectorios*/
	
	
	//Desliega formulario para agregar materias
	public function addmaterias($newidioma=null){
		$this->setupIdioma($newidioma);
		
		$this->load->model('admcursos');		
		$datos['cursosr'] =$this->admcursos->obtener_cursos();
		
		$this->load->model('admusuarios');
		$datos['profesores'] =$this->admusuarios->obtener_profesores_activos();
	
		$datos['idiomas'] =$this->consultas->getIdiomas();		
						
		$this->load->view('admmaterias/agregar',$datos);
	} /*addmaterias*/
	
	
	//Desliega formulario para subir
	public function addfiles($newidioma=null){
		$this->setupIdioma($newidioma);
		
		$datos['cursosr'] =$this->admmaterias->obtener_cursos();		
		
		$res=$this->load->view('admmaterias/cargar_archivos',$datos);		
		
	} /*addfiles*/
	
	
	//Genera opciones para submenú	
	public function adminmaterias($newidioma=null){
		$this->setupIdioma($newidioma);
		
		$datos = array(
				      'submenu' =>array
							   ('<a href="materias/addmaterias">'.$this->lang->line('make').'</a>',
								'<a href="materias/findmaterias">'.$this->lang->line('find').'</a>',
							    '<a href="materias/listmaterias">'.$this->lang->line('list').'</a>',
							    //'<a href="materias/adddirectorios">'.$this->lang->line('make').' '.$this->lang->line('folder').'</a>',
							    '<a href="materias/addfiles">'.$this->lang->line('uploadfiles').'</a>',
							    '<a href="materias/exp_repo">'.$this->lang->line('explore').'</a>'							    							    
							   )			      							   
				);						
		$this->load->view('admmaterias/mainmateria',$datos);
	} /*admincursos*/
	
	
	//Registra los datos del usuario desde el controlador
	public function crear_carpeta(){		
		$curso=$this->input->post('curso_r');
		$mat=$this->input->post('materia_r');		
		$direct=$this->input->post('carpeta');
			
		$tit=$this->security->xss_clean($direct);
	
		$datos['res']=$this->admmaterias->crear_directorio($mat,$direct);
		
		$this->load->view('admmaterias/ruta',$datos);
				
	} /*regcursos*/	
	
	
	//Encontrar cursos
	public function encmaterias($offset = 0,$newidioma=null){
		$this->setupIdioma($newidioma);	
	
		$parametro1=$this->input->post('parametro1');
		if ((isset($parametro1)) && ($parametro1 != "")) {
			unset($_SESSION['parametro1']);
			$_SESSION['parametro1']=$parametro1;
		}/*if*/
					
		$uri_segment=3;
		$offset=$this->uri->segment($uri_segment);
		
		$datos['indice']=$offset;
		
		if($offset==0)$datos['indice']=0;		
		$this->load->library('pagination');
		
		//Verificando que las sesión se encuentre definida

		if ((isset($_SESSION['parametro1'])) && ($_SESSION['parametro1']!="")) {
			$datos['materias_r']=$this->admmaterias->obtener_lista_paginada_filt($_SESSION['parametro1'],$this->limit,$offset);
			$config['total_rows']=$this->admmaterias->contar_todos_filtro($_SESSION['parametro1']);	
		}/*if*/
		
		if($config['total_rows']==0){
			$this->load->view('noregistros');
		}else{
			$config['base_url']=site_url('materias/encmaterias/');
			$config['first_link'] = $this->lang->line('linkfirst');
			$config['last_link'] = $this->lang->line('linklast');
			$config['next_link'] = $this->lang->line('linknext');
			$config['per_page']=$this->limit;
			$config['prev_link'] = $this->lang->line('linkprev');
					
			$config['uri_segment']=$uri_segment;
			
			$this->pagination->initialize($config);
			$datos['paginacion']=$this->pagination->create_links();			
			$datos['filtro']=true;
			$datos['total_reg']=$config['total_rows'];
			$this->load->view('admmaterias/listar',$datos);
		}/*if*/
    } /*enccursos*/
    
    
    public function exp_repo($newidioma=null){		
		$this->setupIdioma($newidioma);
		
		$datos['cursosr'] =$this->admmaterias->obtener_cursos();
		
		$datos['asignaturas'] =$this->admmaterias->obtener_materias();	
		
		$this->load->view('repositorio',$datos);		
    } /*exp_repo*/
    
	
	//Desliega formulario de búsqueda
	public function findmaterias($newidioma=null){
		$this->setupIdioma($newidioma);	
		
		$datos['idiomas'] =$this->consultas->getIdiomas();	
		
		//Borrando variables de búsquedas anteriores
		unset($_SESSION['parametro1']);
		unset($_SESSION['parametro2']);	
						
		$this->load->view('admmaterias/listarfiltro',$datos);
	} /*findmaterias*/
	
	
	public function listmaterias($offset = 0,$newidioma=null){
		$this->setupIdioma($newidioma);	
		$uri_segment=3;
		$offset=$this->uri->segment($uri_segment);
		
		$datos['materias_r']=$this->admmaterias->obtener_lista_paginada($this->limit,$offset);
		$datos['indice']=$offset;
		
		if($offset==0)$datos['indice']=0;
		$this->load->library('pagination');
		
		$config['total_rows']=$this->admmaterias->contar_todos();	
		if($config['total_rows']==0){
			$this->load->view('noregistros');
		}else{			
			$config['base_url']=site_url('materias/listmaterias/');
			$config['first_link'] = $this->lang->line('linkfirst');
			$config['last_link'] = $this->lang->line('linklast');
			$config['next_link'] = $this->lang->line('linknext');
			$config['per_page']=$this->limit;
			$config['prev_link'] = $this->lang->line('linkprev');
			$config['uri_segment']=$uri_segment;
			
			$this->pagination->initialize($config);
			$datos['paginacion']=$this->pagination->create_links();			
			$datos['filtro']=false;
			
			$datos['total_reg']=$config['total_rows'];	
			$this->load->view('admmaterias/listar',$datos);
		}/*if*/
    } /*listusuarios*/
    	
	
	/*Realizar nueva búsqueda*/
	function nencmaterias(){
		unset($_SESSION['parametro1']);
	} /*nenccursos*/
	
	
	//Registra los datos del usuario desde el controlador
	public function regmaterias(){		
		$curso=$this->input->post('curso_r');
		$tit=$this->input->post('materia_c');		
		$estado=$this->input->post('estado');
		$idioma=$this->input->post('idioma');
		$docentes=$this->input->post('profesores');
		$encargado=$this->input->post('titular');
			
		$tit=$this->security->xss_clean($tit);
	
		$res=$this->admmaterias->addmateria($curso,$tit,$estado,$idioma,$encargado,$docentes);
		if($res) echo 1;	//Se agregó correctamente										
		else echo 0;		//No se pudo agregar
				
	} /*regmaterias*/	
	
	
	function setupIdioma($newidioma=null){
		if (!(is_null($newidioma))){//si el usuario no ha seleccionado cambiar de idioma
			$_SESSION["idioma"]=$newidioma;		   
		}
		if (!isset($_SESSION["idioma"])){
			$this->config->set_item('language', 'spanish');//idioma por defecto
			$this->lang->load('spanish','spanish');
			$_SESSION["idioma"]="es";
		}else{
			if($_SESSION["idioma"]=="en"){//cargar inglés
				$this->config->set_item('language', 'english');
				$this->lang->load('english','english');
			}
			elseif ($_SESSION["idioma"]=="es"){//cargar español
				$this->config->set_item('language', 'spanish');
				$this->lang->load('spanish','spanish');        
			} /*if*/
		} /*if*/
	} /*setupIdioma*/
	
	
	public function tree($newidioma=null){		
		$this->setupIdioma($newidioma);
		
		$idmateria=$this->input->post('parametro');
		
		$datos['ruta_rep']=$_SERVER['DOCUMENT_ROOT']."/uploads/repmateria".$idmateria."/";
		
		$datos['cod_mat']=$idmateria;
		
		$this->load->view('arbol',$datos);
    } /*tree*/ 
    
    
	/*
	 * $filtro: Se ocupa para saber si tiene filtro y determinar cuál div se debe recargar
	 * $pag: Se ocupa en la acción de "Volver" para saber desde cuál página de la lista se hace la consulta
	 * $acc: Si va a modificar o editar
	 * $id:  Id del curso
	 * */
	public function vermateria($filtro,$pag=0,$acc,$id,$newidioma=null){
		$this->setupIdioma($newidioma);	
		
		$datos['materia']=$this->admmaterias->obtener_materia($id);		
		$datos['idioma']=$this->consultas->obtener_idioma_instancia($datos['materia'][0]->lang);
		
		$datos['proferores_resp']=$this->admmaterias->obtener_profesores($datos['materia'][0]->codMateria);
		
		$datos['pro_titular']=$this->admmaterias->obtener_profesor_titular($datos['materia'][0]->codMateria);
		
		$this->load->model('admcursos');
		$datos['curso']=$this->admcursos->obtener_titulo_crs($datos['materia'][0]->codCurso);	
		
		$datos['p']=$pag;				//Desde qué página se realiza la consulta para saber a cuál página regresar 
		$datos['tienefiltro']=$filtro;	//Saber si se tratra de una página filtrada o no.
		
		if($acc=="v")$this->load->view('admmaterias/ver',$datos);
		else if($acc=="e"){
			$datos['cursosr'] =$this->admcursos->obtener_cursos();
			$this->load->model('admusuarios');
			$datos['profesores'] =$this->admmaterias->obtener_profesores_disponibles($datos['materia'][0]->codMateria);
			$datos['encargados'] =$this->admmaterias->obtener_profesores_asinados($datos['materia'][0]->codMateria);			
			//$datos['profesores'] =$this->admmaterias->obtener_profesores_disponibles($datos['materia'][0]->codMateria);
			$datos['idiomas']=$this->consultas->getIdiomas();						//Para el caso que fuera actualización
			$this->load->view('admmaterias/editar',$datos);
		}/*if*/
    } /*vercurso*/
    
    
    /*
     * Permite consultar un recurso relacionado a una pregunta (cuando exista dicha relación)
     * */
    public function ver_rec_pregunta($idr){
			
		$this->load->model('admarchivos');
				
		$datos['tipo_rec']=$this->admarchivos->obtener_tipo_recurso($idr);
		$datos['ruta_rec']=$this->admarchivos->obtener_ruta_rec($idr);
		$this->load->view('desplegar_rec',$datos);
    } /*ver_rec_pregunta*/
}
