<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Principal extends CI_Controller
{
	
	function __construct()
	{
		parent::__construct();
		$this->load->model('login');
		$this->load->model('consultas');
		$this->load->helper('url');
		$this->load->helper('form');
	}	
	
	function index($newidioma=null){
		$this->setupIdioma($newidioma);		 
           
		//Si no recibimos ningún valor proveniente del formulario, significa que el usuario recién ingresa:
        if(!isset($_POST['user_name'])){
			//Por lo tanto le presentamos la pantalla del formulario de ingreso: 
			$this->load->view('login');      
        }
        else{//Si el usuario ya pasó por la pantalla inicial y presionó el botón para poder entrar		
			
        } 	
	}
	
	function setupIdioma($newidioma=null){
		if (!(is_null($newidioma))){//si el usuario no ha seleccionado cambiar de idioma
			$_SESSION["idioma"]=$newidioma;		   
		}
		if (!isset($_SESSION["idioma"])){
			$this->config->set_item('language', 'spanish');//idioma por defecto
			$this->lang->load('spanish','spanish');
			$_SESSION["idioma"]="es";
		}else{
			if($_SESSION["idioma"]=="en"){//cargar inglés
				$this->config->set_item('language', 'english');
				$this->lang->load('english','english');
			}
			elseif ($_SESSION["idioma"]=="es"){//cargar español
				$this->config->set_item('language', 'spanish');
				$this->lang->load('spanish','spanish');        
			} /*if*/
		} /*if*/
	} /*setupIdioma*/
	
	public function check_user(){		
		$usr=$this->input->post('user_name');
		$clv=$this->input->post('password');
		$usr = $this->security->xss_clean($usr);
		$clv = $this->security->xss_clean($clv);
		//Comprobamos que el usuario exista en la base de datos y la password ingresada sea correcta
		$ExisteUsuarioyPassoword=$this->login->ValidarUsuario($usr,$clv);
		
		//La variable $ExisteUsuarioyPassoword recibe valor TRUE si el usuario existe y FALSE en caso que no. Este valor lo determina el modelo.
		if($ExisteUsuarioyPassoword){
			//Verifico si el usuario se encuestra activado
			if($this->login->EnabledUser($usr)){
				//iniciando sesion
				$_SESSION['usuario']=$usr; 				
				echo 1;
				
			}else echo 0;
        }
        else{
            echo 0;
        } /*if*/
	} /*check_user*/
		
	public function salir(){
		session_destroy();
		echo 1; 	       
	} /*salir*/
	
	public function cerrarsesion(){
		session_destroy();
		redirect('/principal/', 'refresh'); 	       
	} /*cerrarsesion*/	
	
	public function obtener_tipos_usr(){		
		$id_idioma=$this->input->post('parametro');		
		$tipos = $this->consultas->getTipos($id_idioma);
		
		$opciones="";
		foreach($tipos as $dato=>$valor){
			$opciones.="<option value=\"".$valor[0]."\">".$valor[1]."</option>";	
		}
				
		$datos['listaopt']=$opciones;
		$this->load->view('opciones_select',$datos);
	} /*obtener_tipos_usr*/
}
