<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Usuarios extends CI_Controller
{
	private $limit=3;
	function __construct()
	{
		parent::__construct();
		$this->load->model('consultas');
		$this->load->model('admusuarios');
		$this->load->helper('url');
		$this->load->helper('form');		
	}	
	
	function index($newidioma=null){
		$this->setupIdioma($newidioma);		 
           
		//Si no recibimos ningún valor proveniente del formulario, significa que el usuario recién ingresa:
        if(!isset($_POST['user_name'])){
			//Por lo tanto le presentamos la pantalla del formulario de ingreso: 
			$this->load->view('login');      
        }
        else{//Si el usuario ya pasó por la pantalla inicial y presionó el botón para poder entrar		
			
        } 	
	}/*index*/
	
	
	//Registra los datos del usuario desde el controlador
	public function actusuarios(){		
		$usr=$this->input->post('user');
		$nombres=$this->input->post('nombres');
		$apellidos=$this->input->post('apellidos');		
		$genero=$this->input->post('genero');
		$email=$this->input->post('email');
		$estado=$this->input->post('estado');
		$idioma=$this->input->post('idioma');
		$tipo=$this->input->post('tipo');
		
		$nuevaclave=false;
		if($this->input->post('reinpwd')==1){
			$clave=$this->input->post('pass');
			$clave=$this->security->xss_clean($clave);
			$nuevaclave=true;
		}/*if*/

		$nombres=$this->security->xss_clean($nombres);
		$apellidos=$this->security->xss_clean($apellidos);		
		$genero=$this->security->xss_clean($genero);
		$email=$this->security->xss_clean($email);
		$estado=$this->security->xss_clean($estado);
		$idioma=$this->security->xss_clean($idioma);
		$tipo=$this->security->xss_clean($tipo);
				
		$res=$this->admusuarios->updtusuario($usr,$nombres,$apellidos,$genero,$email,$estado,$clave,$tipo,$idioma,$nuevaclave);
		if($res) echo 1;	//Se actualizó correctamente										
		else echo 0;		//No se pudo actualizar
				
	} /*actusuarios*/
	
	
	//Desliega lista de administración de usuarios
	public function addusuarios($newidioma=null){
		$this->setupIdioma($newidioma);	
		
		$datos['idiomas'] =$this->consultas->getIdiomas();		
						
		$this->load->view('admusuarios/agregar',$datos);
	} /*addusuarios*/
	
	
	//Genera opciones para submenú	
	public function adminusuarios($newidioma=null){
		$this->setupIdioma($newidioma);
		
		$datos = array(
				      'submenu' =>array
							   ('<a href="usuarios/addusuarios">'.$this->lang->line('make').'</a>',
								'<a href="usuarios/findusuarios">'.$this->lang->line('find').'</a>',
							    '<a href="usuarios/listusuarios">'.$this->lang->line('list').'</a>'							    
							   )			      							   
				);						
		$this->load->view('admusuarios/mainusuario',$datos);
	} /*adminusuarios*/
	
	
	public function encusuarios($offset = 0,$newidioma=null){
		$this->setupIdioma($newidioma);	
	
		$parametro1=$this->input->post('parametro1');
		$parametro2=$this->input->post('parametro2');
		if ((isset($parametro1)) && ($parametro1 != "")) {
			unset($_SESSION['parametro1']);
			$_SESSION['parametro1']=$parametro1;
		}/*if*/
		if ((isset($parametro2)) && ($parametro2 != "")) {
			unset($_SESSION['parametro2']);
			$_SESSION['parametro2']=$parametro2;
		}/*if*/
			
		$uri_segment=3;
		$offset=$this->uri->segment($uri_segment);
		
		$datos['indice']=$offset;
		
		if($offset==0)$datos['indice']=0;		
		$this->load->library('pagination');
		
		//Verificando que las sesiones se encuentren definidas

		if (((isset($_SESSION['parametro1'])) && ($_SESSION['parametro1']!="")) && ((isset($_SESSION['parametro2'])) && ($_SESSION['parametro2']!=""))){
			$datos['usuarios_r']=$this->admusuarios->obtener_lista_paginada_filt($_SESSION['parametro1'],$_SESSION['parametro2'],$this->limit,$offset);
			$config['total_rows']=$this->admusuarios->contar_todos_filtro($_SESSION['parametro1'],$_SESSION['parametro2']);				 
		}else if ((isset($_SESSION['parametro1'])) && ($_SESSION['parametro1']!="")) {
			$datos['usuarios_r']=$this->admusuarios->obtener_lista_paginada_filt($_SESSION['parametro1'],null,$this->limit,$offset);
			$config['total_rows']=$this->admusuarios->contar_todos_filtro($_SESSION['parametro1'],null);	
		}else if ((isset($_SESSION['parametro2'])) && ($_SESSION['parametro2']!="")) {
			$datos['usuarios_r']=$this->admusuarios->obtener_lista_paginada_filt(null,$_SESSION['parametro2'],$this->limit,$offset);
			$config['total_rows']=$this->admusuarios->contar_todos_filtro(null,$_SESSION['parametro2']);	
		}/*if*/
		
		if($config['total_rows']==0){
			$this->load->view('noregistros');
		}else{
			$config['base_url']=site_url('usuarios/encusuarios/');
			$config['first_link'] = $this->lang->line('linkfirst');
			$config['last_link'] = $this->lang->line('linklast');
			$config['next_link'] = $this->lang->line('linknext');
			$config['per_page']=$this->limit;
			$config['prev_link'] = $this->lang->line('linkprev');
					
			$config['uri_segment']=$uri_segment;
			
			$this->pagination->initialize($config);
			$datos['paginacion']=$this->pagination->create_links();			
			$datos['filtro']=true;
			$datos['total_reg']=$config['total_rows'];
			$this->load->view('admusuarios/listar',$datos);
		}/*if*/
    } /*encusuarios*/
	
	
	//Desliega lista de administración de usuarios
	public function findusuarios($newidioma=null){
		$this->setupIdioma($newidioma);	
		
		$datos['idiomas'] =$this->consultas->getIdiomas();	
		
		//Borrando variables de búsquedas anteriores
		unset($_SESSION['parametro1']);
		unset($_SESSION['parametro2']);	
						
		$this->load->view('admusuarios/listarfiltro',$datos);
	} /*findusuarios*/
	
	
	public function listusuarios($offset = 0,$newidioma=null){
		$this->setupIdioma($newidioma);	
		$uri_segment=3;
		$offset=$this->uri->segment($uri_segment);
		
		$datos['usuarios_r']=$this->admusuarios->obtener_lista_paginada($this->limit,$offset);
		$datos['indice']=$offset;
		
		if($offset==0)$datos['indice']=0;
		$this->load->library('pagination');
		
		$config['total_rows']=$this->admusuarios->contar_todos();	
		if($config['total_rows']==0){
			$this->load->view('noregistros');
		}else{			
			$config['base_url']=site_url('usuarios/listusuarios/');
			$config['first_link'] = $this->lang->line('linkfirst');
			$config['last_link'] = $this->lang->line('linklast');
			$config['next_link'] = $this->lang->line('linknext');
			$config['per_page']=$this->limit;
			$config['prev_link'] = $this->lang->line('linkprev');
			$config['uri_segment']=$uri_segment;
			
			$this->pagination->initialize($config);
			$datos['paginacion']=$this->pagination->create_links();			
			$datos['filtro']=false;
			
			$datos['total_reg']=$config['total_rows'];	
			$this->load->view('admusuarios/listar',$datos);
		}	
    } /*listusuarios*/
	
	
	//Nueva búsqueda
	function nencusuarios(){
		unset($_SESSION['parametro1']);
		unset($_SESSION['parametro2']);	
	} /*nencusuarios*/
	
	
	//Registra los datos del usuario desde el controlador
	public function regusuarios(){		
		$usr=$this->input->post('user');
		$nombres=$this->input->post('nombres');
		$apellidos=$this->input->post('apellidos');
		$clave=$this->input->post('pass');
		$genero=$this->input->post('genero');
		$email=$this->input->post('email');
		$estado=$this->input->post('estado');
		$idioma=$this->input->post('idioma');
		$tipo=$this->input->post('tipo');
		
		$usr=$this->security->xss_clean($usr);
		$nombres=$this->security->xss_clean($nombres);
		$apellidos=$this->security->xss_clean($apellidos);
		$clave=$this->security->xss_clean($clave);
		$genero=$this->security->xss_clean($genero);
		$email=$this->security->xss_clean($email);
		
		if($this->admusuarios->existeusuario($usr)) echo 2;
		else {
			$res=$this->admusuarios->addusuario($usr,$nombres,$apellidos,$genero,$email,$estado,$clave,$tipo,$idioma);
			if($res) echo 1;	//Se agregó correctamente										
			else echo 0;		//No se pudo agregar
		}/*if*/	
	} /*regusuarios*/
	
		
	function setupIdioma($newidioma=null){
		if (!(is_null($newidioma))){//si el usuario no ha seleccionado cambiar de idioma
			$_SESSION["idioma"]=$newidioma;		   
		}
		if (!isset($_SESSION["idioma"])){
			$this->config->set_item('language', 'spanish');//idioma por defecto
			$this->lang->load('spanish','spanish');
			$_SESSION["idioma"]="es";
		}else{
			if($_SESSION["idioma"]=="en"){//cargar inglés
				$this->config->set_item('language', 'english');
				$this->lang->load('english','english');
			}
			elseif ($_SESSION["idioma"]=="es"){//cargar español
				$this->config->set_item('language', 'spanish');
				$this->lang->load('spanish','spanish');        
			} /*if*/
		} /*if*/
	} /*setupIdioma*/
	
	
	/*
	 * $filtro: Se ocupa para saber si tiene filtro y determinar cuál div se debe recargar
	 * $pag: Se ocupa en la acción de "Volver" para saber desde cuál página de la lista se hace la consulta
	 * $acc: Si va a modificar o editar
	 * $id:  Id del usuario
	 * */
	public function verusuario($filtro,$pag=0,$acc,$id,$newidioma=null){
		$this->setupIdioma($newidioma);	
		
		$datos['usuario']=$this->admusuarios->obtener_usuario($id);		
		$datos['idioma']=$this->consultas->obtener_idioma_instancia($datos['usuario'][0]->lang);
		$datos['tipo']=$this->admusuarios->obtener_tipo_usr($datos['usuario'][0]->tipo,$datos['usuario'][0]->lang);
		$datos['p']=$pag;				//Desde qué página se realiza la consulta para saber a cuál página regresar 
		$datos['tienefiltro']=$filtro;	//Saber si se tratra de una página filtrada o no.
		
		if($acc=="v")$this->load->view('admusuarios/ver',$datos);
		else if($acc=="e"){
			$datos['idiomas']=$this->consultas->getIdiomas();						//Para el caso que fuera actualización
			$datos['tipos']=$this->consultas->getTipos($datos['usuario'][0]->lang);	//Para el caso que fuera actualización
			$this->load->view('admusuarios/editar',$datos);
		}
    } /*verusuario*/
}
