<?php
/**
* 
*/
class Admcursos extends CI_Model{
	
	private $limit=1;
	
	function __construct()
    {
        // Call the Model constructor
        parent::__construct();
    }
    
    //Agregar curso
    function addcurso($tit,$desc,$est,$l){
		$data = array(
			'titulo' => $tit,
			'descripcion' => $desc,
			'estado' => $est,
			'lang' => $l
		);
		
		if($this->db->insert('cursos', $data)) {				
			return true;
		}
		else return false;        
    }/*addcurso*/
   
   	
    function contar_todos(){
		return $this->db->count_all('cursos');
	}/*contar_todos*/
    
    
    function contar_todos_filtro($titulo_f){		
		$query = $this->db->like('titulo', $titulo_f);		
		$query = $this->db->order_by('titulo');
		$query = $this->db->get('cursos');
		return $query->num_rows();
	}/*contar_todos_filtro*/
	
	
	//Devuele los datos de un curso
	function obtener_curso($id){		
		$query = $this->db->where('codCurso' , $id)->get('cursos');
		if($query->num_rows>0){
			return $query->result();
		}/*if*/
	}/*obtener_curso*/
    
    
    //Devuelve el id y el título de todos los cursos sin excepción
    function obtener_cursos(){
		$query = $this->db->select('codCurso,titulo');
		$query = $this->db->order_by('titulo');
		$query = $this->db->where('estado' , 1)->get('cursos');
        if($query->num_rows>0){
			$n=-1;
			foreach($query->result() as $row){
				$n++;
				$datos[$n] = array($row->codCurso,$row->titulo);								
			} /*foreach*/
			return $datos;			
		} /*if*/
    }/*obtener_cursos*/
    
	    
    function obtener_lista_paginada($limit,$offset=0){		
		$query = $this->db->select('cursos.codCurso,cursos.titulo,cursos.estado,idiomas.idioma');
		$query = $this->db->join('idiomas', 'idiomas.codIdioma=cursos.lang','inner');		
		$query = $this->db->order_by('cursos.titulo');
		$query = $this->db->get('cursos',$limit,$offset);
		if($query->num_rows>0){
			return $query->result();
		}/*if*/
	}/*obtener_lista_paginada*/
	
	
	function obtener_lista_paginada_filt($titulo_f,$limit,$offset=0){		
		$query = $this->db->select('cursos.codCurso,cursos.titulo,cursos.estado,idiomas.idioma');
		$query = $this->db->join('idiomas', 'idiomas.codIdioma=cursos.lang','inner');
		$query = $this->db->like('cursos.titulo', $titulo_f);		
		$query = $this->db->order_by('cursos.titulo');
		$query = $this->db->get('cursos',$limit,$offset);
		
		if($query->num_rows>0){
			return $query->result();
		}/*if*/	
	}/*obtener_lista_paginada_filt*/
	
	
	function obtener_materias($id){
		$query = $this->db->select('codMateria,materia');
		$query = $this->db->order_by('materia');
		$query = $this->db->where('codCurso', $id)->get('materias');
		if($query->num_rows>0){
			$n=-1;
			foreach($query->result() as $row){
				$n++;
				$datos[$n] = array($row->codMateria,$row->materia);		
			} /*foreach*/
			return $datos;
		}/*if*/
	}/*obtener_materias*/
	
	function obtener_titulo_crs($id){
		$query = $this->db->select('titulo');
		$query = $this->db->where('codCurso' , $id)->get('cursos');
		if($query->num_rows>0){
			foreach($query->result() as $row){				
				return $row->titulo;
			} /*foreach*/			
		}/*if*/	
	}/*obtener_titulo_us*/
	  
   
   	//Actualizar datos de curso
    function updtcurso($id,$t,$d,$e,$l){
		$data = array(
			'titulo' => $t,
			'descripcion' => $d,			
			'estado' => $e,
			'lang' => $l
		);
				
		$this->db->where('codCurso', $id);	
		if($this->db->update('cursos', $data)) {				
			return true;
		}
		else return false;        
    }/*updtcurso*/
}
