<?php
/**
* 
*/
class Admmaterias extends CI_Model{
	
	private $limit=1;
	
	function __construct()
    {
        // Call the Model constructor
        parent::__construct();
    }
    
    //Agregar materia
    function addmateria($cu,$mat,$est,$l,$tit,$profs){
		$data = array(
			'codCurso' => $cu,
			'materia' => $mat,
			'estado' => $est,
			'titular' => $tit,
			'lang' => $l
		);
		
		if($this->db->insert('materias', $data)) {//En caso de éxito, agregar profesores
			$nuevoid=$this->db->insert_id();
			$profesores = explode(",",$profs);
			foreach($profesores as $profesor){
				$datap = array(
					'codMateria' => $nuevoid,
					'codUsuario' => $profesor	
				);				
				$this->db->insert('profesores_mat', $datap);		
			}/*foreach*/
			$carpetamat="repmateria".$nuevoid;			
			mkdir("uploads/".$carpetamat,0777);
			mkdir("uploads/".$carpetamat."/img",0777);
			mkdir("uploads/".$carpetamat."/videos",0777);
			return true;
		}					
		else return false;        
    }/*addmateria*/
   
   	
   	function crear_directorio($idmateria,$directorio){		
		chmod("uploads/repmateria".$idmateria,0777);		
		if (file_exists("uploads/repmateria".$idmateria."/".$directorio)) {
			return 0;
		} else {
			mkdir("uploads/repmateria".$idmateria."/".$directorio,0777);
		}/*if*/
		chmod("uploads/repmateria".$idmateria,0777);
		return 1;	
	}/*contar_todos_filtro*/
	
	
    function contar_todos(){
		return $this->db->count_all('materias');
	}/*contar_todos*/
    
    
    function contar_todos_filtro($titulo_f){		
		$query = $this->db->like('materia', $titulo_f);		
		$query = $this->db->order_by('materia');
		$query = $this->db->get('materias');
		return $query->num_rows();
	}/*contar_todos_filtro*/
	
	
	//Devuelve los cursos que poseen materias registradas
	function obtener_cursos(){
		// Primero obtengo el código de los cursos
		// de la tambla materias
		$query = $this->db->distinct();
		$query = $this->db->select('codCurso')->get('materias');		
        
        if($query->num_rows>0){			
			foreach($query->result() as $row){				
				$mat[] = $row->codCurso;		
			} /*foreach*/					
		} /*if*/		
		
		$query = $this->db->select('codCurso,titulo');
		$query = $this->db->where_in('codCurso',$mat);
		$query = $this->db->order_by('titulo');
		$query = $this->db->where('estado' , 1)->get('cursos');
        if($query->num_rows>0){
			$n=-1;
			foreach($query->result() as $row){
				$n++;
				$datos[$n] = array($row->codCurso,$row->titulo);								
			} /*foreach*/
			return $datos;			
		} /*if*/		
	}/*obtener_cursos*/
	
	
	/*
	 * Devolver una imagen o video desde el repositorio
	 * */
	function obtener_recurso($id,$t){
		$array = array('codMateria' => $id, 'tipo_rec' => $t);
		$query = $this->db->select('idRecurso,nombre_rec');	
		$query = $this->db->where($array)->get('recursos');
		if($query->num_rows>0){
			return $query->result();
		}/*if*/
	}/*obtener_recurso*/
	
	
	function obtener_lista_paginada($limit,$offset=0){		
		$query = $this->db->select('cursos.titulo as crs,materias.codMateria,materias.materia,materias.estado,idiomas.idioma');
		$query = $this->db->join('idiomas', 'idiomas.codIdioma=materias.lang','inner');		
		$query = $this->db->join('cursos', 'cursos.codCurso = materias.codCurso','inner');	
		$query = $this->db->order_by('cursos.titulo');
		$query = $this->db->order_by('materias.materia');
		$query = $this->db->get('materias',$limit,$offset);
		if($query->num_rows>0){
			return $query->result();
		}/*if*/
	}/*obtener_lista_paginada*/
	
	
	function obtener_lista_paginada_filt($titulo_f,$limit,$offset=0){		
		$query = $this->db->select('cursos.titulo as crs,materias.codMateria,materias.materia,materias.estado,idiomas.idioma');
		$query = $this->db->join('idiomas', 'idiomas.codIdioma=materias.lang','inner');		
		$query = $this->db->join('cursos', 'cursos.codCurso = materias.codCurso','inner');	
		$query = $this->db->like('materias.materia', $titulo_f);		
		$query = $this->db->order_by('materias.materia');
		$query = $this->db->order_by('crs');
		$query = $this->db->get('materias',$limit,$offset);
		
		if($query->num_rows>0){
			return $query->result();
		}/*if*/	
	}/*obtener_lista_paginada_filt*/

	
	function obtener_materia($id){		
		$query = $this->db->where('codMateria' , $id)->get('materias');
		if($query->num_rows>0){
			return $query->result();
		}/*if*/
	}/*obtener_materia*/
	
	function obtener_materias(){
		$query = $this->db->select('codMateria,materia');
		$query = $this->db->order_by('materia')->get('materias');
		if($query->num_rows>0){
			$n=-1;
			foreach($query->result() as $row){
				$n++;
				$datos[$n] = array($row->codMateria,$row->materia);		
			} /*foreach*/
			return $datos;
		}/*if*/
	}/*obtener_materias*/
	
	
	function obtener_profesores($id){
		$query = $this->db->select('CONCAT( usuariosys.nombUsuario, \' \',usuariosys.apellUsuario ) AS profesor',false);
		$query = $this->db->join('profesores_mat', 'usuariosys.codUsuario = profesores_mat.codUsuario','inner');	
		$query = $this->db->where('profesores_mat.codMateria' , $id)->get('usuariosys');
		if($query->num_rows>0){
			return $query->result();
		}/*if*/
	}/*obtener_profesores*/
	
	function obtener_profesores_asinados($idmateria){
		$array = array('profesores_mat.codMateria' => $idmateria, 'usuariosys.estado' => 1);
		$query = $this->db->select('usuariosys.codUsuario,usuariosys.nombUsuario,usuariosys.apellUsuario');
		$query = $this->db->join('profesores_mat', 'usuariosys.codUsuario = profesores_mat.codUsuario','inner');
		$query = $this->db->where($array)->get('usuariosys');		
        if($query->num_rows>0){
			$n=-1;
			foreach($query->result() as $row){
				$n++;
				$datos[$n] = array($row->codUsuario,$row->nombUsuario,$row->apellUsuario);		
			} /*foreach*/
			return $datos;			
		} /*if*/	
	}/*obtener_lista_paginada_filt*/
	
	//Buscar los usuarios disponibles para una materia
	function obtener_profesores_disponibles($idmateria){
		// Primero obtengo el código de los profesores
		// que han sido asignados
		 
		$query = $this->db->select('usuariosys.codUsuario');
		$query = $this->db->join('profesores_mat', 'usuariosys.codUsuario = profesores_mat.codUsuario','inner');
		$query = $this->db->where('profesores_mat.codMateria',$idmateria)->get('usuariosys');		
        
        if($query->num_rows>0){			
			foreach($query->result() as $row){				
				$prof[] = $row->codUsuario;		
			} /*foreach*/					
		} /*if*/
		
		// Ahora a buscar los profesores que no están asignados al curso
		$array = array('estado' => 1, 'tipo' => 'pro');
		$query = $this->db->select('codUsuario,nombUsuario,apellUsuario');
		$query = $this->db->where_not_in('codUsuario',$prof);
		$query = $this->db->where($array);
		$query = $this->db->get('usuariosys');	
        if($query->num_rows>0){
			$n=-1;
			foreach($query->result() as $row){
				$n++;
				$datos[$n] = array($row->codUsuario,$row->nombUsuario,$row->apellUsuario);		
			} /*foreach*/
			return $datos;			
		} /*if*/		
	}/*obtener_profesores_disponibles*/
	
	
	function obtener_profesor_titular($idmateria){
		$query = $this->db->select('usuariosys.codUsuario, usuariosys.nombUsuario, usuariosys.apellUsuario');
		$query = $this->db->join('materias', 'usuariosys.codUsuario = materias.titular','inner');
		$query = $this->db->where('materias.codMateria',$idmateria)->get('usuariosys');		
        if($query->num_rows>0){
			$n=-1;
			foreach($query->result() as $row){
				$n++;
				$datos[$n] = array($row->codUsuario,$row->nombUsuario,$row->apellUsuario);								
			} /*foreach*/
			return $datos;			
		} /*if*/
    }/*getIdiomas*/
	  
   
   	//Actualizar datos de curso
    function updtmateria($c,$t,$e,$l,$tit,$docentes,$i){
		$data = array(
			'codCurso' => $c,
			'materia' => $t,		
			'estado' => $e,
			'titular' => $tit,
			'lang' => $l
		);
				
		$this->db->where('codMateria', $i);	
		if($this->db->update('materias', $data)) {
			//si actualizó correctamente, actualizar la tabla profesores_mat			
			$this->db->delete('profesores_mat', array('codMateria' => $i));			
			$profesores = explode(",",$docentes);
			foreach($profesores as $profesor){
				$datap = array(
					'codMateria' => $i,
					'codUsuario' => $profesor	
				);				
				$this->db->insert('profesores_mat', $datap);		
			}/*foreach*/			
			return true;
		}
		else return false;        
    }/*updtcurso*/
}
